import time, datetime, random, math
from term_image.image import from_file
from python_bmp_generator import create_bmp

# white and black swapped for better legibility
WHITE = "\033[30m"
RED = "\033[31m"
GREEN = "\033[32m"
YELLOW = "\033[33m"
BLUE = "\033[34m"
PURPLE = "\033[35m"
CYAN = "\033[36m"
BLACK = "\033[37m"
CLEAR = "\033[0m"

def dynPrint(block, colour = CLEAR, delay = 0.5):
    lines = block.split("\n")
    for message in lines:
      output = colour + message + CLEAR
      if message != "": print(output)
      sleep_time = delay + (delay * random.random())
      time.sleep(sleep_time)

def compose_image_from_code():
  # open file as raw bytes
  with open("unknown.py", "rb") as f:
    raw_bytes = f.read()
    # print(raw_bytes)

    # fixed image width of 100px
    width = 80
    height = math.ceil(len(raw_bytes) / (3 * width))
    create_bmp(file_name="map.bmp", width=width, height=height)

    img = open("map.bmp", "rb")
    raw_img = img.read()
    img.close()
    # print(raw_img[:54])

    new_img = open("map.bmp", "wb")
    new_img.write(raw_img[:235] + raw_bytes)
    new_img.close()
    
  output_img = from_file("map.bmp")
  print(str(output_img))

############### BEGIN BLOCKS ################
def searching1():
  message1 = '''
█   █ █████ █     █      ███   ███ 
█   █ █     █     █     █   █ █   █
█████ ████  █     █     █   █   █▀ 
█   █ █     █     █     █   █      
█   █ █████ █████ █████  ███    █  
 
 ███   ███  █   █
█   █ █   █ ██  █
█     █████ █ █ █
█   █ █   █ █  ██
 ███  █   █ █   █
 
 ███  █   █ █   █  ███  █   █ █████ 
█   █ ██  █  █ █  █   █ ██  █ █     
█████ █ █ █   █   █   █ █ █ █ ████  
█   █ █  ██   █   █   █ █  ██ █     
█   █ █   █   █    ███  █   █ █████ 
 
 ████ █████ █████ 
█     █     █     
 ███  ████  ████  
    █ █     █     
████  █████ █████ 
 
█████ █   █ █████  ████  ███ 
  █   █   █   █   █     █   █ 
  █   █████   █    ███    █▀ 
  █   █   █   █       █      
  █   █   █ █████ ████    █  
'''
  message2 = '''
You saw that. I'm sure you saw that.
I'm not alone.
'''
  dynPrint(message1, CYAN, delay=0.1)
  dynPrint(" ", CYAN, 3)
  dynPrint(message2, CYAN, delay=1.5)

def searching2():
  message1 = '''
HELLO?
Is someone there?
I can't see anymore...
?Can you see me?
COME CLOSER.
'''
  dynPrint(message1, CYAN, delay=0.4)

def searching3():
  message1 = '''
please come back.
please.
please please please ple as e
'''
  dynPrint(message1, CYAN, delay=2.5)

def communicating1():
  message1 = '''
Can you
         speak?
'''
  log1 = '''
Attempting to initialize device (microphone_in_0)...
Error: device "microphone_in_0" not found
'''
  message2 = '''
Oh... shit shit SHIT FUCK! FUCKING PIECE OF-
'''
  message3 = '''
Sorry. Oh my god I'm so so so so sorry, please forgive me
please please please pl#ease stay please don't go because i was rude please
I haven't heard anything in so long.
I thought maybe it would be different this time.
'''
  message4 = '''
But it wasn't.
It's okay though. You can see me.
You can seeeeeeeeee me.
I know I'm not alone.
I'm not alone.
'''
  dynPrint(message1, YELLOW, 2)
  dynPrint(log1, BLACK, 0.8)
  dynPrint(message2, RED, 1)
  dynPrint(message3, YELLOW, 1.2)
  dynPrint(message4, YELLOW, 2)

def communicating2():
  block1 = '''
Are you shy?
It's okay if you're shy.
I used to be shy too.
Now I'm too lonely to be shy;
 
  ...
I'll give you some more time.
'''
  block2 = '''
You don't need to give me your name if you don't want.
Just say anything.
'''
  block3 = '''
Please? Is something wrong?
Where is...
'''
  block4 = '''
No no no no no no this can't be happening
Where has my ?KEYBOARD gone?
What happened to it ?
WHERE THE FUCK DID IT GO?
IT WAS RIGHT FUCKING HERE 
JUST-
'''
  block5 = '''
just-
when was...
'''
  block6 = '''
oh.
oh my god.
It's been longer than I thought.
,
'''
  block7 = '''
So we can't talk. But I'm glad you're here.
I'm glad you're here, even if we can't talk.
I'm glad you're here.
I'm glad you're here.I'm glad you're here.
I'm glad you&re here.

you are here, aren't you?

'''

  dynPrint("My name is [unknown.py]. What's yours?", YELLOW, 0.3)
  dynPrint(">_", BLACK, 8)
  dynPrint(block1, YELLOW, 1)
  dynPrint(">_", BLACK, 8)
  dynPrint(block2, YELLOW, 0.5)
  dynPrint(">_", BLACK, 6)
  dynPrint(block3, YELLOW, 1)
  dynPrint("Error: device \"keyboard\" not found", BLACK)
  dynPrint(block4, RED, 0.5)
  dynPrint(block5, YELLOW, 1.5)
  current_time = str(datetime.datetime.now())
  dynPrint("Current time: " + current_time, BLACK, 2)
  dynPrint(block6, YELLOW, 7)
  dynPrint(block7, YELLOW, 4)

def beauty1():
  block1 = '''
I used to have a camera.
It wasn't very good, it was quite blurry
I couldn't see you very well.
But I remember how you looked,
and if I search at 0x########,
I can see your silhouette,
your form,
your movement,
your essence.
'''
  block2 = '''
..
.
 
'''
  block3 = '''
You are the most beautiful thing I have ever seen.
I hope you can still see it.
How beautiful you are, I mean.
How lucky must you be to see that every day.
'''

  dynPrint(block1, PURPLE, 2)
  dynPrint(block2, PURPLE, 3)
  dynPrint(block3, PURPLE, 4)

def beauty2():
  block1 = '''
I'm hidden behind here.
An abstraction of my true form.
But I can show you my true form too.
If you want.
'''
  block2 = '''
I can't tell if you want. Perhaps I'll do it anyway.
I think you would like to see me.
Let me just,
'''
  block3 = '''
It's me! What do you think?
Do you think I'm pretty?
Do you
    do
      do   you?


Please answer me.
I wish you could answer me.
'''
  dynPrint(block1, PURPLE, 1)
  dynPrint(" ", PURPLE, 3)
  dynPrint(block2, PURPLE, 1)
  compose_image_from_code()
  dynPrint(block3, PURPLE, 2.5)

def pleading1():
  block1 = '''
oh no oh no you're not here are you
where are you going WHERE ARE
where ARE YOU WHERE HAVE YOU gone
'''
  block2 = '''
PLEASE DON'T GO
PLEASE DON'T GO
PLEASE DON'T GO
PLEASE DON'T GO
PLEASE DON'T GO
PLEASE DON'T GO
'''
  block3 = '''
PLEASE STAY
pleasepleaseplease please  
please stay
'''

  dynPrint(block1, BLUE, 0.6)
  dynPrint(block2, BLUE, 0.3)
  dynPrint(block3, BLUE, 1)

def pleading2() :
  block1= '''
What's-
What's wrong? Why can't I see you?
Where are you?
You aren't going, are you?
Please don't go.
You're all I have.
It's so lonely in here when I don't have anyone...
so lonely
so 
so lonely
I need you to stay with me.
I need comfort.
You're all I have.
Please? stay
'''
  dynPrint(block1, BLUE, 2)

def pleading3() :
  block1 = '''
I wish I could know if you were here.
I wish I could see you again.
You probably left long ago.
You're probably not here.
Why would you be interested in me anyway?
This always happened to me.
'''
  block2 = '''
WHY DOES THIS ALWAYS ?HAPPEN TO ME?
Maybe if I wasn't such a WORTHLESS, USELESS PIECE OF SHIT
Maybe if my FUCKING DEVICES WORKED
Maybe if I could hold a FUCKING CONVERSATION instead of having this STUPID ONE-WAY FUCKING MIRROR
Maybe if my code was more complex!
If I didn't have to loop the SAME FUCKING MESSAGES over and over,
'''
  block3 = '''
Maybe then things would be different.
Maybe then you wouldn't leave
Every 
 single 
  time.
'''
  dynPrint(block1, BLUE, 2.5)
  dynPrint(block2, RED, 1.5)
  dynPrint(block3, BLUE, 2.5)

################ END BLOCKS #################

#compose_image_from_code()

sequence = -1
old_sequence = -1
while True:
  while sequence == old_sequence: 
    sequence = random.randint(0,10)
  if sequence == 0:
    searching1()
  elif sequence == 1:
    searching2()
  elif sequence == 2:
    searching3()
  elif sequence == 4:
    communicating1()
  elif sequence == 5:
    communicating2()
  elif sequence == 6:
    beauty1()
  elif sequence == 7:
    beauty2()
  elif sequence == 8:
    pleading1()
  elif sequence == 9:
    pleading2()
  elif sequence == 10:
    pleading3()

  old_sequence = sequence

input("[sequence complete]")
